Robot Simulator of the Robotics Group for Self-Organization of Control: SliderWheelie Class Reference

# SliderWheelie Class Reference

This is a class, which models an annular robot. More...

`#include <sliderwheelie.h>`

Inherits lpzrobots::OdeRobot.

Collaboration diagram for SliderWheelie:
[legend]

List of all members.

## Public Member Functions
| SliderWheelie (const OdeHandle &odeHandle, const OsgHandle &osgHandle, const SliderWheelieConf &conf, const std::string &name, const std::string &revision="")
virtual | ~SliderWheelie ()
virtual void | place (const osg::Matrix &pose)
| sets the pose of the vehicle
virtual void | update ()
| update the OSG notes here
void | doInternalStuff (GlobalData &global)
| this function is called in each simulation timestep (always after control).
virtual void | setMotors (const motor *motors, int motornumber)
| sets actual motorcommands
virtual int | getSensors (sensor *sensors, int sensornumber)
| returns actual sensorvalues
virtual int | getSensorNumber ()
| returns number of sensors
virtual int | getMotorNumber ()
| returns number of motors
virtual Primitive * | getMainPrimitive () const
| return the primitive of the robot that is used for tracking and camera following
virtual std::vector< Primitive * > | getAllPrimitives () const
| returns a list of all primitives of the robot (used to store and restore the robot)
virtual void | notifyOnChange (const paramkey &key)
| Is called when a parameter was changes via setParam().
## Static Public Member Functions
static SliderWheelieConf | getDefaultConf ()

## Detailed Description

This is a class, which models an annular robot.

It consists of a number of equal elements, each linked by a joint powered by 1 servo

## Constructor & Destructor Documentation

SliderWheelie | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle,
|  | const SliderWheelieConf & | conf,
|  | const std::string & | name,
|  | const std::string & | revision = `""` |
| ) |  |  |

~SliderWheelie | ( |  | ) | `[virtual]`

## Member Function Documentation

void doInternalStuff | ( | GlobalData & | globalData | ) | `[virtual]`

this function is called in each simulation timestep (always after control).

It should perform robot-internal checks and actions like resetting certain sensors or implement velocity dependend friction and the like. The attached Motors should act here.

Parameters:

  | globalData | structure that contains global data from the simulation environment

Reimplemented from OdeRobot.

virtual std::vector<Primitive*> getAllPrimitives | ( |  | ) | const`[inline, virtual]`

returns a list of all primitives of the robot (used to store and restore the robot)

Reimplemented from OdeRobot.

static SliderWheelieConf getDefaultConf | ( |  | ) | `[inline, static]`

virtual Primitive* getMainPrimitive | ( |  | ) | const`[inline, virtual]`

return the primitive of the robot that is used for tracking and camera following

Reimplemented from OdeRobot.

virtual int getMotorNumber | ( |  | ) | `[inline, virtual]`

returns number of motors

Implements AbstractRobot.

virtual int getSensorNumber | ( |  | ) | `[inline, virtual]`

returns number of sensors

Implements AbstractRobot.

int getSensors | ( | sensor * | sensors,
|  | int | sensornumber |
| ) |  |  | `[virtual]`

returns actual sensorvalues

Parameters:

  | sensors | sensors scaled to [-1,1]
  | sensornumber | length of the sensor array

Returns:
  number of actually written sensors

Implements AbstractRobot.

void notifyOnChange | ( | const paramkey & | key | ) | `[virtual]`

Is called when a parameter was changes via setParam().

Note that it is not called of parameters of childs are changed, then there notifyOnChange() method is called. The key and of the changed parameter (use getParam() to retrieve its actual value). Overload this function when special actions have to be taken on parameter changes.

Reimplemented from Configurable.

void place | ( | const osg::Matrix & | pose | ) | `[virtual]`

sets the pose of the vehicle

Parameters:

  | pose | desired 4x4 pose matrix

Implements OdeRobot.

void setMotors | ( | const motor * | motors,
|  | int | motornumber |
| ) |  |  | `[virtual]`

sets actual motorcommands

Parameters:

  | motors | motors scaled to [-1,1]
  | motornumber | length of the motor array

update center position

Implements AbstractRobot.

void update | ( |  | ) | `[virtual]`

update the OSG notes here

Implements OdeRobot.

The documentation for this class was generated from the following files:

- sliderwheelie.h
- sliderwheelie.cpp